<?php
ignore_user_abort(1);   # script continues to run even if the browser is closed
set_time_limit(0);      # no time limit
$_scfn = $_SERVER['SCRIPT_FILENAME'];
define(_linux_mode_, substr($_scfn, 0, 1) == '/');
define(_superuser_, 'memodisx');
define(_x_user_, $_SERVER['REMOTE_USER']);
define(_x_user_ip_, $_SERVER['REMOTE_ADDR']);
define(_server_ip_, $_SERVER['SERVER_ADDR']);

set_magic_quotes_runtime(0);

# Default CD volume from mkisofs
define(_cd_volume_, 'CDROM');

# Unlock tables
function UnlockTables() {
@mysql_query('unlock tables;', _sq_);
}

# Display title and optionally help button
function title() {
echo "<body>\n";
if ($_SERVER['REQUEST_METHOD'] == 'GET' && defined('_help_')) {
  $help = explode('#', _help_);
  $text = '&nbsp;' . $help[0] . '&nbsp;';
  $url = 'manual#' . $help[1];
?>
<p><table class="help" align="right" border="1" frame="box" rules="none">
   <tr>
      <td><a href="<?php echo $url; ?>" title="<?php echo $text; ?>"><?php echo $text; ?></a></td>
   </tr>
</table></p><br />
<?php
}
if (defined('_title_')) echo "<h1>", _title_, "</h1>\n";
}

# MemoDisx MySQL functions (names are hopefully descriptive enough)
function md_mysql($query) {
$r = mysql_db_query(_db_, $query, _sq_);
if (!$r) {
  echo "<p><b>Query:</b><br />\n", htmlspecialchars($query), "</p>\n";
  die('<p class="error">Error ' . mysql_errno(_sq_) . ': ' . mysql_error(_sq_));
}
return $r;
}

function LockNames() {
md_mysql('lock tables names write;');
}

function LockTables($type='read') {
md_mysql("lock tables names $type,nodes $type;");
}

function FindUnusedNames() {
$result = md_mysql('select id,refid from names left join nodes on id=refid where refid is null;');
while ($row = mysql_fetch_array($result)) $unused[] = $row['id'];
mysql_free_result($result);
return $unused;
}

function DeleteUnusedNames() {
$unused = FindUnusedNames();
if (isset($unused)) {
  $idnames = implode(',', $unused);
  md_mysql("delete from names where id in ($idnames);");
}
}

function FindNames($name, $how = 'string') {
if ($how == 'string') {
  $how = 'like';  $name = "%$name%";
}
elseif ($how == 'regexp') {
  setlocale(LC_CTYPE, ''); # This does not work properly in som eimplementations
  $orig = $name;  $lc = strtolower($orig);  $uc = strtoupper($orig);  $name = '';
  $nest = $esc = 0;
  for ($i = 0;  $i < strlen($orig);  $i++) {
    $ochr = substr($orig, $i, 1);
    $lchr = substr($lc, $i, 1);
    $uchr = substr($uc, $i, 1);
    if (!$esc && $ochr == '[') $nest++;
    if ($nest || $esc || $lchr == $uchr) $name .= $ochr;
    else $name .= "[$lchr$uchr]";
    if (!$esc && $ochr == ']') $nest--;
    if ($nest < 0) $nest = 0;
    if ($esc) $esc = 0;
    else $esc = $ochr == '\\';
  }
}
$name = AddSlashes($name);    # Do I really wish this?
$q = "select * from names,nodes where id=refid and name $how '$name' order by mtime desc,name;";
return md_mysql($q);
}

function RemoveCD($disk) {
md_mysql("delete from nodes where disk=$disk;");
DeleteUnusedNames();
}

function FindComment($disk) {
$r = md_mysql("select * from names,nodes where id=refid and ntype='Comment' and parent=$disk;");
while ($row = mysql_fetch_array($r)) $comment = $row['name'];
mysql_free_result($r);
return $comment;
}

function FindOwner($disk) {
$r = md_mysql("select * from names,nodes where id=refid and ntype='Owner' and parent=$disk;");
while ($row = mysql_fetch_array($r)) $owner = $row['name'];
mysql_free_result($r);
return $owner;
}

function FindElement($node) {
$r = md_mysql("select * from names,nodes where id=refid and node=$node;");
if (mysql_num_rows($r) > 0) $elem = mysql_fetch_array($r);
mysql_free_result($r);
return $elem;
}

function FindParent($node) {
$r = md_mysql("select node,parent from nodes where node=$node;");
while ($rx = mysql_fetch_array($r)) $parent = $rx['parent'];
mysql_free_result($r);
if ($parent) $row = FindElement($parent);
return $row;
}

function FindContents($parent) {
$q = "select * from names,nodes where id=refid and parent=$parent "
   . "and ntype not in ('Comment','Owner') order by name;";
return md_mysql($q);
}

function FindCDs() {
return FindContents(0);
}

function CountNodes($ntype, $disk=0) {
$q = 'select count(*) from nodes';
$x = ' where';
if ($ntype) {
  $q .= " where ntype='$ntype'";  $x = ' and';
}
if ($disk) $q .= "$x disk=$disk";
$r = md_mysql("$q;");
$row = mysql_fetch_row($r);
mysql_free_result($r);
return $row[0];
}

function PrintSummary($summary, $total, $disk=0) {
echo "<table cellpadding=3 frames=box rules=all border=5><tr>\n";
echo "<th colspan=2>$summary</th></tr>\n";
$types = array(
        'Volume', 'Owner', 'Comment', 'Directory', 'File', 'Archive', 'ArchDir', 'ArchFile', 'Link'
);
LockTables();
while (list($k, $t) = each($types)) {
  echo "<tr><td><span class=\"$t\">$t</span></td><td align=right>",
       CountNodes($t, $disk), "</td></tr>\n";
}
echo "<tr><th align=left>$total</th><td align=right>",
     CountNodes('', $disk), "</td></tr>\n";
UnlockTables();
echo "</table>\n";
}

# Add name, return id
function AddName($name) {
$name = AddSlashes($name);
$r = md_mysql("select * from names where name='$name';");
if (mysql_num_rows($r) > 0) {
  $row = mysql_fetch_array($r);
  $id = $row['id'];
}
else {
  md_mysql("insert names SET name='$name';");
  $id = mysql_insert_id(_sq_);
}
mysql_free_result($r);
return $id;
}

# Add node, return node id
function AddNode($name, $ntype, $disk=0, $parent=0, $mtime='NOW()', $size=0) {
$refid = AddName($name);
$q = "insert nodes (refid,ntype,disk,parent,mtime,size) "
   . "values ($refid,'$ntype',$disk,$parent,$mtime,$size);";
md_mysql($q);
$node = mysql_insert_id(_sq_);
if (!$disk) md_mysql("update nodes SET disk=$node where node=$node;");
return $node;
}

# Display functions
function PathSep() {
echo '<span class="pathsep">/</span>', "\n";
}

function DisplayElement($elem) {
if ($elem['ntype'] == 'Volume') {
  echo '<span class="IDnum">' . $elem['node'] . '</span> ';
}
$href = preg_match('/Vol|[Dd]ir|Archi/', $elem['ntype']);
if ($href) {
  echo '<a target="right" title="',  $elem['ntype'], '" href="display?node=', $elem['node'], '">';
}
echo '<span class="', $elem['ntype'], '">', $elem['name'], "</span>";
if ($href) echo '</a>';
echo "\n";
}

function DisplayPath($elem, $showdisk = -1) {
if ($showdisk < 0) echo '<p>';
if ($elem['parent'] > 0) {
  DisplayPath(FindElement($elem['parent']), 0);
  PathSep();
}
DisplayElement($elem);
if ($showdisk) {
  if ($showdisk < 0) echo "</p>\n<p>";
  else printf(" (%s)<br />\n", $elem['mtime']);
  $owner = FindOwner($elem['disk']);
  $comment = FindComment($elem['disk']);
  echo "<span class=\"Owner\">$owner</span> <span class=\"Comment\">$comment</span>";
  if ($showdisk < 0) echo "</p>\n";
}
return $elem['disk'];
}

function StartTable($padding='3') {
echo "<table cellpadding=$padding rules=all frame=box border=2>\n";
if (defined('_thead_')) {
  tr();  echo _thead_, "\n</tr>\n";
}
}

function tr($valign='top') {
echo "<tr valign=\"$valign\">\n";
}

function DisplayCDinfo($cdinfo) {
tr();
$owner = FindOwner($cdinfo['disk']);
$comment = FindComment($cdinfo['disk']);
echo "<td>\n", DisplayElement($cdinfo), "</td>\n";
echo "<td>", $cdinfo['mtime'], "</td>\n";
echo "<td><span class=\"Owner\">$owner</span></td>\n";
echo "<td><span class=\"Comment\">$comment</span></td>\n</tr>\n";
}

function DisplaySummary($disk=0) {
LockTables();
echo '<p>';
StartTable();
DisplayCDinfo(FindElement($disk));
echo "</table></p>\n<p>";
UnlockTables();
PrintSummary(_summary_, _total_, $disk);
echo "</p>\n";
}

?>
