<?php
if (Manual('Instalace', 'install')) {
?>
<p>MemoDisx pracuje v OS/2 a v systmech typu Unix. Pokud jej zkuste pout ve Windows, MemoDisx
si bude myslet, e pracuje v OS/2. Mon to bude fungovat, ale nen to testovno ani podporovno.</p>

<p>MemoDisx vyaduje nsledujc softwarov nstroje:</p>
<ul>
<li>Apache 1.3.10 nebo vy s povolenm vkldnm kdu na stran serveru (server-side includes
= SSI)</li>
<li>PHP 4 (s PHP&nbsp;3 nebude fungovat)</li>
<li>MySQL 3.22.19 nebo vy</li>
<li>Prohle WWW podporujc rmy, CSS2 a JavaScript (JavaScript je doporuen, ale nen vyadovn)</li>
</ul>

<p>Dal poadavky zvs na operanm systmu:</p>
<ul>
<li>OS/2 mus mt instalovn Rexx. Apache jako i dal nstroje vyaduj EMX.</li>
<li>Unixov verze je zvisl na standardnch utilitch <code>ls</code>, <code>df</code>,
<code>mount</code>, <code>umount</code> a <code>isoinfo</code>.</li>
</ul>

<p>Chcete-li ukldat obsah archiv, muste mt <code>InfoZip</code>, <code>tar</code>,
<code>gzip</code> a <code>bzip2</code>. Nen nutn mt vechny zmnn programy, pozdji si
zvolte, kter z nich chcete uvat.</p>

<p>MemoDisx vyuv techniky <a title="Content negotiation" target="_blank"
href="http://hroch486.icpf.cas.cz/wagner/content-negotiation">sjednn obsahu (content
negotiation)</a>. Ne budete s
instalac pokraovat, muste nakonfigurovat Apache pro pouit <a title="MultiViews" target="_blank"
href="http://hroch486.icpf.cas.cz/manual/mod/mod_negotiation.html">MultiViews</a>. Obvykle je to
ji nakonfigurovno, ale konfiguran soubor v distribuci me mt chybu v definici eskho jazyka.
Sprvn kd ISO pro etinu je <b>cs</b>, ne <b>cz</b>!</p>

<p>MemoDisx je nyn dostupn v anglitin a v etin. Ujistte se, e konfiguran soubor nat
<code>negotiation_module</code> a obsahuje nsledujc direktivy:</p>

<pre>
AddLanguage en .en
AddLanguage cs .cs
AddCharset iso-8859-2 .iso8859-2
</pre>

<p>Je povoleno piadit ke kadmu jazyku i nkolik ppon. Mete si definovat i dal jazyky.</p>

<p>Dle byste si mli nakonfigurovat jazyky ve svm prohlei WWW. Primrnm jazykem programu
MemoDisx je anglitina. Ujistte se, e konfigurace vaeho prohlee WWW obsahuje obecnou
anglitinu.</p>

<p>MemoDisx podporuje pouze jednu databzi spolenou vem uivatelm. Muste-li pouvat vce
oddlench databz, je nutn vytvoit nkolik samostatnch kopi programu MemoDisx.</p>

<p>Nejprve mus bt vytvoena databzov tabulka administrtorem MySQL. Pkazy jsou pipraveny v
souboru <code>incl.dbcreate.txt</code>. Ped jejich pouitm zmte alespo heslo.</p>

<p>Nyn mete pipravit soubory pro Apache. Zkoprujte cel adres na msto, kde Apache oekv
soubory PHP.
<b>Tento adres mus mt povolen zpisu pro uivatele, pod nm b Apache!</b>
Nezapomete pout <code>umask&nbsp;0</code>, jinak nebudete moci nastavit prvo zpisu vem
uivatelm!
Ujistte se, e je povoleno vkldn kdu na stran serveru (SSI). Pak muste
nakonfigurovat MemoDisx s pouitm pkaz ze souboru <code>incl.htaccess</code> (vlote je do
hlavnho konfiguranho souboru). Obsah je vysvtlen v nsledujcm textu.</p>

<pre>
# MemoDisx configuration
# ======================
# PHP4 and SSI must be enabled.
# MySQL must be installed on the same host.
# AddLanguage and AddCharset directives must be properly set.
# The system will NOT work without register_globals off.
# SSL is not necessary but recommended unless you access MemoDisx
# from your local computer and you are not sure that there is
# no TCP/IP spy which could reveal your password to someone else.

&lt;Directory @@PHPDocumentRoot@@/memodisx&gt;
</pre>

<p>Jmno adrese nahrate jmnem pouitm na vaem serveru.</p>

<pre>
  AllowOverride None
  Options +MultiViews +IncludesNOEXEC
  DirectoryIndex index
</pre>

<p>Tyto direktivy nastavuj pro dan adres SSI a MultiViews.</p>

<pre>
  &lt;IfModule mod_php4.c&gt;
    # AddType application/x-httpd-php php
    php_flag magic_quotes_gpc off
    php_flag magic_quotes_runtime off
    php_admin_flag register_globals off
  &lt;/IfModule&gt;
</pre>

<p>PHP m vhodu v tom, e lze v konfiguraci Apache nastavit odlin parametry pro kad adres.
Proto nebudeme mnit <code>php.ini</code>, abychom neporuili innost jinch skript.</p>

<p>MemoDisx z bezpenostnch dvod neregistruje globln promnn a sm se star o uvozovky.
Direktiva <code>AddType</code> se obvykle vyskytuje v hlavnm konfiguranm souboru a nemus zde
bt opakovna.</p>

<pre>
  &lt;IfModule mod_ssl.c&gt;
    SSLRequireSSL
  &lt;/IfModule&gt;
</pre>

<p>SSL nen vyadovno, ale je doporueno, pokud si vak nejste jisti, e dn sov pin neme
st vae heslo.</p>

<pre>
  &lt;IfModule mod_expires.c&gt;
    ExpiresActive On
    ExpiresDefault M3
    ExpiresByType text/css "access 1 day"
    ExpiresByType image/gif "access 1 month"
    ExpiresByType image/jpeg "access 1 month"
  &lt;/IfModule&gt;
</pre>

<p>Strnky jsou vytveny dynamicky, proto je nutno dn nastavit jejich expiraci. Bez tohoto
modulu nemus MemoDisx nast nov strnky, ale zobraz star obsah.</p>

<pre>
  &lt;IfModule mod_headers.c&gt;
    &lt;FilesMatch "\.php$"&gt;
      Header append Pragma "no-cache"
      Header set Cache-Control "no-cache, must-revalidate, private"
    &lt;/FilesMatch&gt;
  &lt;/IfModule&gt;
</pre>

<p>Tato st zabrn ukldn obsahu ve vyrovnvac pamti prohlee WWW.</p>

<pre>
  &lt;FilesMatch "incl\."&gt;
    Order allow,deny
    Deny from all
  &lt;/FilesMatch&gt;
</pre>

<p>Tyto soubory obsahuj funkce a citliv informace, kter nesm bt zobrazovny.</p>

<pre>
  AuthGroupFile @@SecurityFiles@@/groups
  AuthUserFile @@SecurityFiles@@/users
  AuthName "MemoDisx"
  AuthType Basic
  require valid-user
  # require group memodisx
  # require user memodisx Alice Bill Dinah Jabberwock Tweedledum Tweedledee
</pre>

<p>Aby se pedelo neautorizovanmu uit, je doporueno (ale nen psn vyadovno) pijet
pstupovch omezen. Mete povolit pstup vem uivatelm, skupin uivatel, nebo vyjmenovanm
uivatelm. Superuivatel <b>memodisx</b> m zvltn prva, je jsou popsna v jinch stech
tohoto nvodu.</p>

<p><i><b>Poznmka:</b> Bill (Vilk) je jetrka z knihy Alenina dobrodrustv v kraji div
(Alice's Advantures in Wonderland). Dinah (Dna) je Alenina koka ze stejn knky. Dal postavy
pochzej z knky Alenka za zrcadlem (Through the Looking Glass and What Alice Found There).
Jabberwock je stvra ze ,,zrcadlov bsn`` (ve starm pekladu vahlav, v novm pekladu
Tlachapoud), Tweedledum a Tweedledee jsou v eskm pekladu brati Tydlidum a Tydlity.</i></p>

<pre>
&lt;/Directory&gt;
</pre>

<p>Mete omezit prva k naten CD vytvoenm souboru file <code>incl.readcd.config.php</code>.
Pklad takovho souboru je dodvn pod nzvem <code>incl.readcd-x.config.php</code>. Mete pout
nsledujc peddefinovan konstanty:</p>

<table>
<tr>
<th align="left">_superuser_</th>
<td>Jmno superuivatele (memodisx)</td>
</tr>
<tr>
<th align="left">_x_user_</th>
<td>Pihlen uivatel</td>
</tr>
<tr>
<th align="left">_x_user_ip_</th>
<td>IP adresa uivatelova potae</td>
</tr>
<tr>
<th align="left">_server_ip_</th>
<td>IP adresa serveru</td>
</tr>
<tr>
<th align="left">_notallowed_</th>
<td>Chybov zprva</td>
</tr>
</table>

<p>Chcete-li si vytvoit demoverzi, ulote kopii souboru <code>incl.demo-x.php</code> pod nzvem
<code>incl.demo.php</code>.</p>

<p>Pokud jste tak jet neuinili, restartujte Apache, ulote kopii souboru
<code>incl.install.php</code> pod nzvem <code>install.php</code> a spuste  <a title="Instalace"
target="_top" href="install">instalan skript</a>. Polo vm nkolik otzek. Muste zadat jmno
hostitele, jmno databze, uivatele a heslo pro MySQL. Pak zadejte, jak archivan a kompresn
programy jsou na vaem potai instalovny. GNU tar se li od ostatnch verz parametrem
<code>-z</code> umoujcm pm zpracovn soubor <code>.tar.gz</code>. Ve verzi pro OS/2 to
nen podporovno. Kompresn programy se pouvaj pouze v ppad, e je zadn tar. Unixov systmy
obvykle obsahuj symbolick linky pojmenovan <code>gunzip</code> a <code>bunzip2</code>. Pokud je
nemte, muste zvolit utility s parametrem <code>-d</code>. Nakonec zvolte vechny mechaniky, z
nich mete natat CD (psmena mechanik v OS/2, ppojn body v Unixu - nepouvejte jmna
zazen).</p>

<p><b>Adres s programem MemoDisx mus mt povolen zpisu pro uivatele, pod nm b Apache!</b></p>

<p>Instalace vytvo soubor <code>incl.constants.php</code> v adresi s programem MemoDisx. Tento
soubor needitujte! Pouze v ppad, e nejste spokojeni s poadm mechanik CD, upravte pole
<code>$_cd_</code>.</p>

<p>Doporuujeme, abyste si s programem nejprve pohrli a nauili se jej pouvat. A zskte pocit,
e ovldn programu rozumte, zkoprujte soubor <code>incl.delete.php</code> pod nzvem
<code>delete.php</code> a s jeho pouitm <a title="Vymazn databze" target="_top"
href="delete">vymate cel obsah databze</a>. na zvr vymate soubory <code>install.php</code> a
<code>delete.php</code>, abyste je nemohli pout omylem.</p>

<?php
}
?>
