<?php
if (Manual('Search for files and directories', 'search')) {
?>

<p>This function is used to search text in volume, file and directory names as well as in comments.
Remember that all names are case sensitive, therefore the search is also case sensitive. You can
search in one of the three following modes:</p>

<ol>
<li><b>string:</b> MemoDisx will try to find the supplied text as a part of any name. This is not
an equality test, it is implemented by search with MySQL syntax. The percent sign, uderscore and
backslash have special meaning. If you wish to use them in the search string, precede them by a
backslash.</li>

<li><b>MySQL expression:</b> expression used by the <code>like</code> comparison described in the
MySQL manual.</li>

<li><b>POSIX regular expression:</b> this type of search tries to be case insensitive. It converts
all characters to character groups so that e.g. <code>inSeNsiTivE</code> will be searched as
<code>[iI][nN][sS][eE][nN][sS][iI][tT][iI][vV][eE]</code>. Conversion is performed using the system
default locale on the server. However, <code>setlocale</code> does not work properly in all
implementations of PHP. Thus accented characters may not be correctly handled. You can supply them
yourselves, e.g. in <code>uj[&eacute;&Eacute;]vi</code> which will be converted to
<code>[uU][jJ][&eacute;&Eacute;][vV][iI]</code>.</li>
</ol>

<p>MemoDisx then displays found items where volumes, directories and archives are hyperlinks to a
detailed view. The detailed view starts with the current path, the CD owner and its comment.
All elements in the path are hyperlinks. The lower part of the window shows the contents of the
directory. The items are visually distinguished. The meaning of the styles can be displayed in the
left frame by selecting the <b>Styles</b> button. Their meaning is as follows:</p>

<table>
<tr valign="top"><td><span class="IDnum">ID</span></td>
<td>Identification number supplied by MemoDisx</td></tr>
<tr valign="top"><td><span class="Volume">Volume</span></td>
<td>Volume label</td></tr>
<tr valign="top"><td><span class="Owner">Owner</span></td>
<td>The user who has read the CD into the database</td></tr>
<tr valign="top"><td><span class="Comment">Comment</span></td>
<td>User supplied comment</td></tr>
<tr valign="top"><td><span class="Directory">Directory</span></td>
<td>Directory name</td></tr>
<tr valign="top"><td><span class="File">File</span></td>
<td>Name of a file not recognised as an archive</td></tr>
<tr valign="top"><td><span class="Archive">Archive</span></td>
<td>Archive known by MemoDisx</td></tr>
<tr valign="top"><td><span class="ArchDir">Arch.&nbsp;Directory</span></td>
<td>Directory inside an archive</td></tr>
<tr valign="top"><td><span class="ArchFile">Archive&nbsp;File</span></td>
<td>File inside an archive</td></tr>
<tr valign="top"><td><span class="Link">Link</span></td>
<td>Name of a symbolic link</td></tr>
</table>

<p>MemoDisx allows duplicate volume labels with one exception. If you do not supply <code>-V</code>
option in <code>mkisofs</code>, the volume label will be <code>CDROM</code>. In this case MemoDisx
will append a number to the volume label.</p>

<p>If you are the owner of the CD or the owner of the CD is empty or you are logged as
<b>memodisx</b>, you will see a button which will enable you to <a href="#remove">remove the CD
from the database</a>.</p>

<?php
}
?>
